----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 10/11/2021 01:37:55 PM
-- Design Name: 
-- Module Name: counter - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity counter is
    Generic ( width : integer := 8); 
    Port ( clk : in STD_LOGIC;
           reset : in STD_LOGIC;
           en : in STD_LOGIC;
           data : out STD_LOGIC_VECTOR (width-1 downto 0));
end counter;

architecture Behavioral of counter is

signal counter : unsigned (width-1 downto 0);


begin

--
-- proces za tevec za led
process (clk)
begin
   if (clk'event and clk = '1') then
      if reset = '1' then
         counter <= (others => '0');
      elsif en='1' then
         counter <= counter + 1;
      end if;
   end if;
end process;

-- pridrui stanje counter-ja izhodu
data <= std_logic_vector(counter);

end Behavioral;
